"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.apmMock = exports.ApmModule = void 0;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _env = require("@lskjs/env");
var _err = _interopRequireDefault(require("@lskjs/err"));
var _module = _interopRequireDefault(require("@lskjs/module"));
var _elasticApmNode = _interopRequireDefault(require("elastic-apm-node"));
var _get3 = _interopRequireDefault(require("lodash/get"));
var _excluded = ["name", "type", "subtype", "action", "status", "err", "time"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var apmMock = {
  startTransaction: function startTransaction() {
    return {
      end: function end() {
        return null;
      },
      startSpan: function startSpan() {
        return {
          end: function end() {
            return null;
          }
        };
      },
      setCustomContext: function setCustomContext() {
        return null;
      },
      addLabels: function addLabels() {
        return null;
      },
      setLabel: function setLabel() {
        return null;
      }
    };
  },
  captureError: function captureError() {
    return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", null);
          case 1:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }))();
  },
  setCustomContext: function setCustomContext() {
    return null;
  },
  addLabels: function addLabels() {
    return null;
  },
  setLabel: function setLabel() {
    return null;
  }
};
exports.apmMock = apmMock;
var ApmModule = /*#__PURE__*/function (_Module) {
  (0, _inherits2["default"])(ApmModule, _Module);
  var _super = _createSuper(ApmModule);
  function ApmModule() {
    var _this;
    (0, _classCallCheck2["default"])(this, ApmModule);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _this.ElasticApm = _elasticApmNode["default"];
    return _this;
  }
  (0, _createClass2["default"])(ApmModule, [{
    key: "init",
    value: function () {
      var _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        var serviceName, _this$config$environm, environment, config;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return (0, _get2["default"])((0, _getPrototypeOf2["default"])(ApmModule.prototype), "init", this).call(this);
            case 2:
              if (!this.config || !this.config.serverUrl) {
                this.config = (0, _get3["default"])(this, 'app.config.apm', {});
              }
              if (!this.config.disabled) {
                _context2.next = 6;
                break;
              }
              this.log.warn('config.disabled');
              return _context2.abrupt("return");
            case 6:
              if (this.config.serverUrl) {
                _context2.next = 9;
                break;
              }
              this.log.warn('!config.serverUrl');
              return _context2.abrupt("return");
            case 9:
              serviceName = this.config.serviceName || (0, _get3["default"])(process, 'env.WORKER') || "nodejs_".concat(_env.stage);
              _this$config$environm = this.config.environment, environment = _this$config$environm === void 0 ? _env.isDev ? (0, _get3["default"])(process, 'env.USER') : process.env.NODE_ENV || 'development' : _this$config$environm;
              config = _objectSpread(_objectSpread({
                logLevel: 'warn'
              }, this.config), {}, {
                environment: environment,
                serviceName: serviceName
              });
              this.log.debug('config', config);
              this.client = this.ElasticApm.start(config);
            case 14:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function init() {
        return _init.apply(this, arguments);
      }
      return init;
    }()
  }, {
    key: "triggerStat",
    value: function () {
      var _triggerStat = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(props) {
        var name, type, subtype, action, status, err, _props$time, time, labels, endTime, startTime, args, tx, result;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              // this.log.trace('[triggerStat]', props);
              name = props.name, type = props.type, subtype = props.subtype, action = props.action, status = props.status, err = props.err, _props$time = props.time, time = _props$time === void 0 ? 0 : _props$time, labels = (0, _objectWithoutProperties2["default"])(props, _excluded);
              endTime = new Date().toISOString();
              startTime = new Date(Date.now() - time).toISOString();
              args = [{
                startTime: startTime
              }];
              if (action) args.push(action);
              if (subtype) args.push(subtype);
              if (type) args.push(type);
              if (name) args.push(name);
              tx = this.startTransaction.apply(this, (0, _toConsumableArray2["default"])(args.reverse()));
              tx.addLabels(labels);
              if (!(status === 'success')) {
                _context3.next = 14;
                break;
              }
              result = status;
              _context3.next = 18;
              break;
            case 14:
              if (!err) {
                _context3.next = 18;
                break;
              }
              result = _err["default"].getCode(err);
              _context3.next = 18;
              return this.captureError({
                code: _err["default"].getCode(err),
                message: _err["default"].getMessage(err)
              });
            case 18:
              _context3.next = 20;
              return tx.end(result, endTime);
            case 20:
              return _context3.abrupt("return", tx);
            case 21:
            case "end":
              return _context3.stop();
          }
        }, _callee3, this);
      }));
      function triggerStat(_x) {
        return _triggerStat.apply(this, arguments);
      }
      return triggerStat;
    }()
  }, {
    key: "startTransaction",
    value: function startTransaction() {
      var _this$client;
      if (!this.client) return apmMock.startTransaction.apply(apmMock, arguments);
      return (_this$client = this.client).startTransaction.apply(_this$client, arguments);
    }
  }, {
    key: "captureError",
    value: function () {
      var _captureError = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
        var _this$client2;
        var _args4 = arguments;
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) switch (_context4.prev = _context4.next) {
            case 0:
              if (this.client) {
                _context4.next = 2;
                break;
              }
              return _context4.abrupt("return", apmMock.captureError.apply(apmMock, _args4));
            case 2:
              return _context4.abrupt("return", (_this$client2 = this.client).captureError.apply(_this$client2, _args4));
            case 3:
            case "end":
              return _context4.stop();
          }
        }, _callee4, this);
      }));
      function captureError() {
        return _captureError.apply(this, arguments);
      }
      return captureError;
    }()
  }, {
    key: "setCustomContext",
    value: function setCustomContext() {
      var _this$client3;
      if (!this.client) return apmMock.setCustomContext.apply(apmMock, arguments);
      return (_this$client3 = this.client).setCustomContext.apply(_this$client3, arguments);
    }
  }, {
    key: "setLabel",
    value: function setLabel() {
      var _this$client4;
      if (!this.client) return apmMock.setLabel.apply(apmMock, arguments);
      return (_this$client4 = this.client).setLabel.apply(_this$client4, arguments);
    }
  }, {
    key: "addLabels",
    value: function addLabels() {
      var _this$client5;
      if (!this.client) return apmMock.addLabels.apply(apmMock, arguments);
      return (_this$client5 = this.client).addLabels.apply(_this$client5, arguments);
    }
  }]);
  return ApmModule;
}(_module["default"]);
exports.ApmModule = ApmModule;
var _default = ApmModule;
exports["default"] = _default;
//# sourceMappingURL=ApmModule.js.map